
#ifndef PLS_ABSTRACT_TASK_H
#define PLS_ABSTRACT_TASK_H

#define PLS_UNIQUE_ID __COUNTER__

#include "pls/internal/base/spin_lock.h"

namespace pls {
    namespace internal {
        namespace scheduling {
            class abstract_task {
                int depth_;
                int unique_id_;
                abstract_task* child_task_;

            public:
                abstract_task(int depth, int unique_id):
                    depth_{depth},
                    unique_id_{unique_id},
                    child_task_{nullptr} {}

                virtual void execute() = 0;
                void set_child(abstract_task* child_task) { child_task_ = child_task; }
                abstract_task* child() { return child_task_; }

                void set_depth(int depth) { depth_ = depth; }
                int depth() { return depth_; }
            protected:
                virtual bool internal_stealing(abstract_task* other_task) = 0;
                virtual bool split_task() = 0;

                bool steal_work();
            };
        }
    }
}

#endif //PLS_ABSTRACT_TASK_H
